SystemOrganization addCategory: #ConfigurationOfAlien!

Object subclass: #ConfigurationOfAlien
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAlien'!

!ConfigurationOfAlien class methodsFor: 'private' stamp: 'tg 1/16/2010 01:03'!
ensureMetacello
	Smalltalk at: #MetacelloProject ifAbsent: [
		Gofer new
				url: 'http://seaside.gemstone.com/ss/metacello';
				package: 'ConfigurationOfMetacello';
				load.
		(Smalltalk at: #ConfigurationOfMetacello) loadLatestVersion ]! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:04'!
loadCore
	(self  project version: '1.0') load: 'Core'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'tg 1/16/2010 01:22'!
loadLatestVersion
	"self loadLatestVersion"

	| project |
	project := self project.
	project updateProject.
	^project latestVersion load! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:05'!
loadLibC
	(self  project version: '1.0') load: 'LibC'! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:04'!
loadMacOSX
	(self  project version: '1.0') load: 'MacOSX'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:09'!
loadTests
	(self  project version: '1.0') load: 'Tests'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:05'!
loadVMMaker
	(self  project version: '1.0') load: 'VMMaker'
! !

!ConfigurationOfAlien class methodsFor: 'loading' stamp: 'FernandoOlivero 1/16/2010 13:05'!
loadWin32
	(self  project version: '1.0') load: 'Win32'! !

!ConfigurationOfAlien class methodsFor: 'metacello tool support' stamp: 'FernandoOlivero 1/13/2010 15:50'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfAlien class methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2010 15:50'!
project

	^self new project! !

!ConfigurationOfAlien methodsFor: 'doits' stamp: 'FernandoOlivero 1/13/2010 15:55'!
alienPostInstall
	(Smalltalk at: #ParseNode) initialize.
	(Smalltalk at: #Alien) initialize.
	(Smalltalk at: #AlienLibrary) initialize.
	(Smalltalk at: #FFICallbackThunk) initialize.
	(Smalltalk at: #Callback) initialize.
	(Smalltalk at: #UnsafeAlien) initialize! !

!ConfigurationOfAlien methodsFor: 'baselines' stamp: 'FernandoOlivero 1/18/2010 08:38'!
baseline10: spec
	<version: '1.0-baseline'>
	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Alien'.
		spec package: 'Alien-Prereqs' with:[ spec preLoadDoIt: #validateSpecialObjectsArray ].
		spec package: 'Alien-Core' with: [ 
			spec requires: #( 'Alien-Prereqs' ) ].
		spec
			package: 'Alien-Examples';
			package: 'Alien-CoreTest' with:[ spec requires: #('Alien-Core') ] ;
			package: 'Alien-MacOSX-Core'  with: [ spec requires: #( 'Alien-Core'  ) ];
			package: 'Alien-MacOSX-AppKit' with:[ spec requires: #('Alien-Core' 'Alien-MacOSX-Core') ] ;
			package: 'Alien-MacOSX-Examples' with:[ spec requires: #('Alien-Core') ] ;
			package: 'Alien-LibC' with:[spec requires: #('Alien-Core')];
			package: 'Alien-Win32' with:[spec requires: #('Alien-Core')];
			package: 'Alien-VMMaker-Support';
			package: 'Alien-VMMaker-Plugins' ;
	           	group: 'default' with: #('Core' );
 	          	group: 'Core' with: #( 'Alien-Core' 'Alien-Examples' );
 	           	group: 'Tests' with: #( 'Alien-CoreTest' );
		       group: 'MacOSX' with: #('Alien-MacOSX-Core' 'Alien-MacOSX-AppKit' 'Alien-MacOSX-Examples');
 	          	group: 'LibC' with: #( 'Alien-LibC');
		       group: 'Win32' with: #( 'Alien-Win32');
		       group: 'VMMaker' with: #( 'Alien-VMMaker-Support'  'Alien-VMMaker-Plugins') ;
			postLoadDoIt: #alienPostInstall ].
! !

!ConfigurationOfAlien methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2010 15:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfAlien methodsFor: 'doits' stamp: 'FernandoOlivero 1/13/2010 16:03'!
validateSpecialObjectsArray
	( ( Smalltalk classNamed: #Alien ) isNil and:[ 
		(Smalltalk specialObjectsArray size = 50) not ] )
		ifTrue:[ ^ self error: 'This version of ALIEN assumes a size of 50 in the array of special objects, if loaded would cause the image to crash!!. Please contact the Alien package developers'].
	! !

!ConfigurationOfAlien methodsFor: 'versions' stamp: 'tg 1/16/2010 01:36'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #pharo do: [
		spec blessing: #release.
		spec 
			package: 'Alien-Prereqs' with: 'Alien-Prereqs-mha.3';
			package: 'Alien-Core' with: 'Alien-Core-John_M_McIntosh.63';
			package: 'Alien-CoreTest' with: 'Alien-CoreTest-F_Olivero.22'.].! !
